package com.microservices.system.service;

import com.microservices.system.api.domain.SysDept;
import com.microservices.system.domain.vo.TreeSelect;

import java.util.List;

/**
 * 部门管理 服务层
 *
 * @author microservices
 */
public interface ISysDeptService
{
    /**
     * 查询部门管理数据
     * 
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    /**
     * 查询部门树结构信息
     * 
     * @param dept 部门信息
     * @return 部门树信息集合
     */
    public List<TreeSelect> selectDeptTreeList(SysDept dept);

    /**
     * 构建前端所需要树结构
     * 
     * @param depts 部门列表
     * @return 树结构列表
     */
    public List<SysDept> buildDeptTree(List<SysDept> depts);

    /**
     * 构建前端所需要下拉树结构
     * 
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    public List<TreeSelect> buildDeptTreeSelect(List<SysDept> depts);

    /**
     * 根据角色ID查询部门树信息
     * 
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    public List<Long> selectDeptListByRoleId(Long roleId);

    /**
     * 根据部门ID查询信息
     * 
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门（正常状态）
     * 
     * @param deptId 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 是否存在部门子节点
     * 
     * @param deptId 部门ID
     * @return 结果
     */
    public boolean hasChildByDeptId(Long deptId);

    /**
     * 查询部门是否存在用户
     * 
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    public boolean checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public boolean checkDeptNameUnique(SysDept dept);

    /**
     * 校验部门是否有数据权限
     * 
     * @param deptId 部门id
     */
    public void checkDeptDataScope(Long deptId);

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public boolean insertDept(SysDept dept);

    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public boolean updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long deptId);

    /**
     * 通过部门Id列表查询部门列表
     *
     * @param ids 部门Id列表
     * @return
     */
    List<SysDept> selectDeptListInIds(List<Long> ids);

    List<Long> getSelfAndChildrenDeptIdListByDeptId(Long deptId);

    /**
     * 检查部门是否可以操作
     *
     * @param deptId
     */
    void checkUnchangeableDept(Long deptId);

    /**
     * 校验组织名称
     *
     * @param deptName
     */
    void checkDeptName(String deptName);

    /**
     * 查询组织编号下拥有传入角色权限字符串的用户名
     *
     * @param deptId
     * @param roleKeys
     * @return
     */
    List<String> getGitLinkUserNamesByDeptIdAndRoleKeys(Long deptId, String roleKeys);

    /**
     * 通过项目管理企业创建组织
     *
     * @param pmsEnterpriseName 企业名称
     * @return 组织Id
     */
    Long addDeptByPmsEnterprise(String pmsEnterpriseName);

    /**
     * 根据部门Id更新部门名称
     *
     * @param deptId   部门id
     * @param deptName 部门名称
     * @return 更新是否成功
     */
    Boolean updateDeptNameByDeptId(Long deptId, String deptName);

    /**
     * 根据部门id删除部门
     *
     * @param deptId 部门id
     * @return 是否删除成功
     */
    Boolean deleteDeptByDeptId(Long deptId);

    /**
     * 通过企业名称删除部门
     *
     * @param pmsEnterpriseName 企业名称
     * @return 删除是否成功
     */
    Boolean deleteDeptByPmsEnterprise(String pmsEnterpriseName);


    /**
     * 根据专区名称创建部门
     *
     * @param zoneName 专区名称
     * @return 部门Id
     */
    Long addDeptByZone(String zoneName);
}
